void swap(List<int> A, int i, int j) {
    int t = A[i]; A[i] = A[j]; A[j] = t;
}

int partition(List<int> A, int p, int r) {
	int x = A[r];
	int i = p - 1;
	for j in range(r - p + 1) {
	    if (A[j+p] <= x) {
	        i++;
	        swap(A, i, j+p);
	    }
	}
	swap(A, i+1, r);
	return i;
}

/* Recursive function to sort list A using quick-sort */
void quicksort(List<int> A, int p, int r) {
	if (p < r) {
	    int q = partition(A, p, r);
	    quicksort(A, p, q-1);
	    quicksort(A, q+1, r);
	}
}

int main () {
    /* Using quicksort */
    List<int> A = [4, 2, 7, 3, 1, 9, 6, 10, 5, 8];
    quicksort(A, 0, len(A) - 1);
    for a in A {
        print(a);
    }
}